//----------------------------------------Liberies including----------------------------------//

#include <ax12.h>                                                 // Liberies for ax12 servo drive	
#include <Wire.h>                                                 // Liberies for I2C bus
#include <BioloidController.h>                                    // Liberies to move 2 parallels servo at the time
#include "poses.h"                                                // Liberies for Position

BioloidController bioloid = BioloidController(1000000);           // Initializing of BioloidController

//----------------------------------------Defining -------------------------------------------//

#define BUTTON0 0                                                 // Defining the Input Button on input 0
#define SERVOCOUNT 8                                              // Defining how many servo drives there are uset

//----------------------------------------Variables-------------------------------------------//

int id;	                                                          // defining "id" to Integer
int pos;                                                          // defining "pos" to Integer
int steps;                                                        // defining "steps" to Integer
int Bit;                                                          // defining "Bit" to Integer
int Place;                                                        // defining "Place" to Integer
int master;                                                       // defining "master" to Integer
int moving;                                                       // defining "moving" to Integer
int stat;                                                         // defining "stat" to Integer

//----------------------------------------Artix-M Board setup---------------------------------//

void setup()
{        
  Serial.begin(9600);                                            // opens serial port, sets data rate to 9600 bps
  Wire.begin(9);                                                 // join i2c bus (address optional for master)
  Wire.onReceive(receiveEvent);                                  // register event
  delay(200);                                                    // Wait 0.2sek
  Wire.onRequest(requestEvent);                                  // register event
  delay (3000);                                                  // Wait 3sek for display to be open
  Serial.println("#################################");           // Print
  Serial.println("Serial Communication Established.");           // Print
  Serial.println("#################################");           // Print
  Serial.println(" ");                                           // Print
  pinMode(BUTTON0, INPUT);                                       // Setpin mode 0 to input
  
  ax12SetRegister2(1, 32, 50);                                   // Set speed to servo drive
  ax12SetRegister2(2, 32, 50);                                   // Set speed to servo drive
  ax12SetRegister2(3, 32, 50);                                   // Set speed to servo drive
  ax12SetRegister2(4, 32, 50);                                   // Set speed to servo drive
  ax12SetRegister2(5, 32, 50);                                   // Set speed to servo drive
  ax12SetRegister2(6, 32, 50);                                   // Set speed to servo drive
  ax12SetRegister2(7, 32, 50);                                   // Set speed to servo drive
  ax12SetRegister2(8, 32, 50);                                   // Set speed to servo drive

  ax12SetRegister2(1, 34, 1023);                                 // Set Torq to servo drive
  ax12SetRegister2(2, 34, 1023);                                 // Set Torq to servo drive
  ax12SetRegister2(3, 34, 1023);                                 // Set Torq to servo drive
  ax12SetRegister2(4, 34, 1023);                                 // Set Torq to servo drive
  ax12SetRegister2(5, 34, 1023);                                 // Set Torq to servo drive
  ax12SetRegister2(6, 34, 1023);                                 // Set Torq to servo drive
  ax12SetRegister2(7, 34, 1023);                                 // Set Torq to servo drive
  ax12SetRegister2(8, 34, 1023);                                 // Set Torq to servo drive


  steps = 0;                                                     // Set steps to 0
  Bit = 0;                                                       // Set Bit to 0
  Place = 9;                                                     // Set Place to 9
  stat = 0;                                                      // Set stat to 0
  moving = 1;                                                    // Set moving to 0
}


//----------------------------------------Step Programming------------------------------------//

void loop() 
{  
  delay(100);                                                     // Wait 0.1sek
       
  }
  //---------------------------------------Home Step-----------------------------------------//
  if (steps == 0)                                                 // Se if Steps is equal to 0
  {
    Serial.println("Program in step 0");                          // Print

    Serial.println("Run arm to homing position");                 // Print

    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos1);                                       // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 1 i position array

    delay(500);                                                   // Wait 0.5sek

    Serial.println("Turn ready signal on");                       // Print
    Bit = 1;                                                      // Set Bit to 1

    Serial.println("Set step to 1");                              // Print
    steps = 1;                                                    // Set Steps to 1
    Serial.println("wait for signal");                            // Print
  }
  
  //-----------------------Ready Step and wait for push button-------------------------------//
  if (steps == 1 && master == 1)                                  // Se if Steps is equal to 1 and master sending 1
  {
    Serial.println("Program in step 1");                          // Print

    Serial.println("Run arm to ready position");                  // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos2);                                       // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 2 i position array

    delay(100);                                                   // Wait 0.1sek

    Place = 9;                                                    // Set Place to 9
    stat = 0;                                                     // Set stat to 0

    delay(500);                                                   // Wait 0.5sek

    Serial.println("Turn ready signal on");                       // Print
    while (stat != 1)                                             // run until stat is 1
    {
      delay(100);                                                 // Wait 0.1sek
      if(digitalRead(0) == HIGH)                                  // Signal from Push bottun
      {
        delay(4000);                                              // Wait 4sek
        if(digitalRead(0) == HIGH)                                // Signal from Push bottun
        {
          Serial.print ("jeg sender 4 : ");                       // Print
          Place = 4;                                              // Set Place to 4
          Serial.print(Place);                                    // Print
          stat = 1;                                               // Set stat to 1
        }
        else                                                      // else
        {
          Serial.print("jeg sender 3 : ");                        // Print
          Place = 3;                                              // Set place to 3
          Serial.print(Place);                                    // Print
          stat = 1;                                               // Set stat to 1
        }
      }
      Serial.print("Place = : ");                                 // Print
      Serial.print(Place);                                        // Print
    }

    Bit = Place;                                                  // se if Bit are Equal to Place
    Serial.println("bit er ");                                    // Print
    Serial.println(Bit);                                          // Print
    Serial.println("Set step to 2");                              // Print
    Serial.println("wait for signal pallet");                     // Print
    steps = 2;                                                    // Print
  }

  //---------------------------------------Palle 1 Step--------------------------------------//
  if (steps == 2 && master == 3)                                  // Se if Steps is equal to 2 and master sending 3
  {
    Serial.println("Program in pallet 1 step 2");                 // Print

    Serial.println("Run arm to pallet 1 ready position");         // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos3);                                       // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 3 i position array
    delay(100);                                                   // Wait 0.1sek

    Serial.println("Run arm to pallet 1 on position");            // Print

    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos4);                                       // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 4 i position array
    delay(100);                                                   // Wait 0.1sek

    Serial.println("Run arm to pallet 1 closed position");        // Print

    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos5);                                       // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 5 i position array
    delay(100);                                                   // Wait 0.1sek

    Serial.println("Run arm to pallet 1 lifted position");        // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos6);                                       // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 6 i position array
    delay(100);                                                   // Wait 0.1sek

    Serial.println("Run arm to pallet 1 lifted and out position"); // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos7);                                       // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 7 i position array
    delay(100);                                                   // Wait 0.1sek

    Serial.println("Run arm to Pallet before dilivering position"); // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos13);                                      // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 13 i position array
    delay(100);                                                   // Wait 0.1sek

    Serial.println("Run arm to Pallet dilivering closed position"); // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos14);                                      // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 14 i position array
    delay(3000);                                                  // Wait 0.1sek

    Serial.println("Turn ready signal on");                       // Print
    Bit = 5;                                                      // Set Bit to 5

    Serial.println("Set step to 3");                              // Print
    Serial.println("wait for signal");                            // Print
    steps = 3;                                                    // Set steps to 3
  }
  
  //---------------------------------------Palle 2 Step--------------------------------------//
  if (steps == 2 && master == 4)                                  // Se if Steps is equal to 2 and master sending 4

  {
    Serial.println("Program in pallet 2 step 2");                 // Print

    Serial.println("Run arm to pallet 2 ready position");         // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos8);                                       // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 8 i position array
    delay(20);                                                    // Wait 0.02sek

    Serial.println("Run arm to pallet 2 on position");            // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos9);                                       // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 9 i position array
    delay(20);                                                    // Wait 0.02sek

    Serial.println("Run arm to pallet 2 closed position");        // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos10);                                      // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 10 i position array
    delay(20);                                                    // Wait 0.02sek

    Serial.println("Run arm to pallet 2 lifted position");        // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos11);                                      // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 11 i position array
    delay(20);                                                    // Wait 0.02sek
 
    Serial.println("Run arm to pallet 2 lifted and out position"); // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos12);                                      // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 12 i position array
    delay(20);                                                    // Wait 0.02sek

    Serial.println("Run arm to Pallet before dilivering position"); // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos13);                                      // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 13 i position array
    delay(20);                                                    // Wait 0.02sek

    Serial.println("Run arm to Pallet dilivering closed position"); // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos14);                                      // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 14 i position array
    delay(3000);                                                  // Wait 3sek

    Serial.println("Turn ready signal on");                       // Print
    Bit = 5;                                                      // Set Bit to 5

    Serial.println("Set step to 3");                              // Print
    Serial.println("wait for signal");                            // Print
    steps = 3;                                                    // Set steps to 3
  }

  //-------------------------------pallet open and dillivered--------------------------------//
  if (steps == 3 && master == 5)                                  // Se if Steps is equal to 3 and master sending 5
  {
    Serial.println("Program in step 3");                          // Print

    Serial.println("Run arm to Pallet dilivering open position closed"); // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos14);                                      // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 14 i position array
    delay(50);                                                    // Wait 0.05sek

    Serial.println("Run arm to Pallet dilivered position open");  // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos15);                                      // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 15 i position array
    delay(50);                                                    // Wait 0.05sek

    Serial.println("Run arm to Pallet dilivered position after"); // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos151);                                     // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 151 i position array
    delay(50);                                                    // Wait 0.05sek

    Serial.println("Run arm to Pallet dilivered position");       // Print
    
    delay(100);                                                   // Wait 0.1sek
    bioloid.loadPose(Pos16);                                      // load the pose from FLASH, into the nextPose buffer
    ServoRunningPos();                                            // Set the function "ServoRunningPos" to read position 16 i position array

    Serial.println("Turn ready signal on");                       // Print
    Bit = 1;                                                      // Set Bit to 1

    Serial.println("Set step to 2");                              // Print
    Serial.println("wait for signal");                            // Print
    steps = 1;                                                    // Set steps to 1
  }

}

//----------------------------Recive command from master---------------------------//

// function that executes whenever data is received from master
// this function is registered as an event, see setup()

void receiveEvent(int howMany) {
  while (1 < Wire.available()) {                              // loop through all but the last
    char c = Wire.read();                                     // receive byte as a character
    Serial.print(c);                                          // print the character
  }
  master = Wire.read();                                       // receive byte as an integer
  Serial.println(master);                                     // print the integer
}

//----------------------------Send command to master-------------------------------//

// function that executes whenever data is requested by master
// this function is registered as an event, see setup()
void requestEvent() {
  Wire.write(Bit);                                            // respond with message of 1 bytes
                                                              // as expected by master
}

//----------------------------------------Servo Running Pos----------------------------------//

void ServoRunningPos()                                        // Servo Running Position function
{
                                                              // bio id start -------------->
  delay(100);                                                 // Wait 0.1sek
  bioloid.readPose();                                         // read in current servo positions to the curPose buffer  
  delay(1000);                                                // Wait 1sek
  bioloid.interpolateSetup(1000);                             // setup for interpolation from current->next over 1/2 a second
  while(bioloid.interpolating > 0){                           // do this while we have not reached our new pose
    bioloid.interpolateStep();                                // move servos, if necessary. 
    delay(3);                                                 // Wait 0.003sek
  }
  while (moving != 0)                                         // The program will loop through this while loop until the robot is at its end position and not moving
  {
    delay(100);                                               // Wait 0.1sek
    moving = ax12GetRegister(1,46,1)+                         // checking if the motors are running. If the result is == 0 no servos is moving
             ax12GetRegister(2,46,1)+                         // checking if the motors are running. If the result is == 0 no servos is moving
             ax12GetRegister(3,46,1)+                         // checking if the motors are running. If the result is == 0 no servos is moving
             ax12GetRegister(4,46,1)+                         // checking if the motors are running. If the result is == 0 no servos is moving
             ax12GetRegister(5,46,1)+                         // checking if the motors are running. If the result is == 0 no servos is moving
             ax12GetRegister(6,46,1)+                         // checking if the motors are running. If the result is == 0 no servos is moving
             ax12GetRegister(7,46,1)+                         // checking if the motors are running. If the result is == 0 no servos is moving
             ax12GetRegister(8,46,1);                         // checking if the motors are running. If the result is == 0 no servos is moving
  }

}



